#ifndef	__USB_RAM_DEFIN_h__
#define	__USB_RAM_DEFIN_h__
//	write your header here

////////////////////////////Global Valuable/////////////////////////
extern unsigned int Mouse_BYTE1;
extern unsigned int Mouse_BYTE2;
extern unsigned int Mouse_BYTE3;
extern unsigned int Mouse_BYTE4;

extern int R_EP0DataCount;
extern unsigned int	 USB_Status;
extern unsigned int	 R_USB_Suspend;
extern unsigned int	 R_USB_State_Machine;

extern unsigned int  R_USB_State_Machine_HID;
extern unsigned int  USB_Status_HID;

extern unsigned long ulTimeout;
//extern unsigned int  unGotoRamStart;

extern unsigned int R_USB_RW_Busy;		//If device is read/write, this flag will be set 1. Otherwise set 0.
extern unsigned int USBD_PlugIn;		//0:Device not connect to PC, 1:Device connect to PC

extern unsigned int gEP0InOutFlag;
extern unsigned int data_send_flag;

////////////////////////////Public function/////////////////////////
void SetIntData(unsigned int addr,unsigned int data);
void INT_IN_Data(void);
void ClearMouseBuffer(void);
void VendorCmdService(void);
void Send_Null(void);
void Send_8_Bytes(void);
void Send_Remain_Bytes(void);
void Setup_Token(void);
void Write_EP0_FIFO(void);
void NotSupport(void);
void RxUSB_RW_Buffer(unsigned int unLength);
void DataPointer(int nTableType);
int  EP0_DataPointer_CallBack(int nTableType);
int  Get_Descriptor_Length(int nType);
unsigned int  GetCMDValueEx(int nIndex);
int TXToUSB(unsigned long Buffer_Address, unsigned int Sector_Number);
int RXFromUSB(unsigned long Buffer_Address, unsigned int Sector_Number);
int TxUSB_RW_Buffer_Word(unsigned int unLength, unsigned int unStartAddr);
void TxUSB_RW_Buffer(unsigned int unLength, unsigned int unStartAddr);
void USB_Initial(void);
void USB_ISR(void);
void USB_Reset(void);
void USBDSuspend_CallBack(void);
void USB_ServiceLoop(unsigned int unUseLoop);
void USBDSuspend_CallBack(void);


#endif
