//main.c
#include "GPL951_Body.h"
#include "USB\USBD_Define.h"
#include "USB\USBD.h"
#include "System\System.h"

int main()
{
	//add your code here
    int Key;						
	
	Key = 0;
	System_Initial();
	
	//USB Intial	
	data_send_flag = 0;
	USB_Reset();
	USB_Initial();	

	__asm("fiq on");
	__asm("irq on");		
		
	while(1)
	{		
		Key = *P_IOF_Data&0xFF00;//SP_GetCh();
		*P_USBD_INTEN |= 0x1000;				
		switch(Key)
		{										
			case 0x0100:
				SetIntData((unsigned int)&Mouse_BYTE1,0x0001);			//Left key
				data_send_flag = 2;
				break; 
										
			case 0x0200:
				SetIntData((unsigned int)&Mouse_BYTE1,0x0002);			//right key
				data_send_flag = 2;
				break;
									
			case 0x0400:
				SetIntData((unsigned int)&Mouse_BYTE2,0x0005);			//X+5
				data_send_flag = 2;
				break;	
			
			case 0x0800:
				SetIntData((unsigned int)&Mouse_BYTE2,0x00fb);			//X-5
				data_send_flag = 2;
				break;	
									
			case 0x1000:
				SetIntData((unsigned int)&Mouse_BYTE3,0x0005);			//Y+5
				data_send_flag = 2;
				break;
			case 0x2000:
				SetIntData((unsigned int)&Mouse_BYTE3,0x00fb);			//Y-5
				data_send_flag = 2;
				break;	
			default:
				break;				
		}
		USB_ServiceLoop(0);			//use usb loop		
		System_ServiceLoop();		//Keyboard Scan		
		if(USBD_PlugIn)
		{
			//USB plug in
		}	
		else
		{
			//USB plug out
		}
	}
	
	*P_USBD_Config=0x00;		//Close USB
	*P_USBD_INTEN=0x00;	
	while(1);	
	return 0;	
}
